CreateGatewayTarget
Creates a target for a gateway. A target defines an endpoint that the gateway can connect to.
Request Syntax
POST /gateways/gatewayIdentifier/targets/ HTTP/1.1
Content-type: application/json
{
"certificateConfigurations": [
{ ... }
],
"clientToken": "string",
"credentialProviderConfigurations": [
{
"credentialProvider": { ... },
"credentialProviderType": "string"
}
],
"description": "string",
"metadataConfiguration": {
"allowedQueryParameters": [ "string" ],
"allowedRequestHeaders": [ "string" ],
"allowedResponseHeaders": [ "string" ]
},
"name": "string",
"privateEndpoint": { ... },
"targetConfiguration": { ... }
}
URI Request Parameters
The request uses the following URI parameters.
- gatewayIdentifier
-
The identifier of the gateway to create a target for.
Pattern:
([0-9a-z][-]?){1,100}-[0-9a-z]{10}Required: Yes
Request Body
The request accepts the following data in JSON format.
- certificateConfigurations
-
The private certificate authority (CA) configurations for the gateway target. Use this to have the gateway trust a private CA when it establishes TLS connections to the target endpoint. Provide each certificate by reference to an Amazon S3 object or an AWS Secrets Manager secret. You can specify only one certificate authority configuration in this list.
Type: Array of CertificateConfiguration objects
Array Members: Fixed number of 1 item.
Required: No
- clientToken
-
A unique, case-sensitive identifier to ensure that the API request completes no more than one time. If you don't specify this field, a value is randomly generated for you. If this token matches a previous request, the service ignores the request, but doesn't return an error. For more information, see Ensuring idempotency.
Type: String
Length Constraints: Minimum length of 33. Maximum length of 256.
Pattern:
[a-zA-Z0-9](-*[a-zA-Z0-9]){0,256}Required: No
- credentialProviderConfigurations
-
The credential provider configurations for the target. These configurations specify how the gateway authenticates with the target endpoint.
Type: Array of CredentialProviderConfiguration objects
Array Members: Fixed number of 1 item.
Required: No
- description
-
The description of the gateway target.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 200.
Required: No
- metadataConfiguration
-
Optional configuration for HTTP header and query parameter propagation to and from the gateway target.
Type: MetadataConfiguration object
Required: No
- name
-
The name of the gateway target. The name must be unique within the gateway.
Type: String
Pattern:
([0-9a-zA-Z][-]?){1,100}Required: No
- privateEndpoint
-
The private endpoint configuration for the gateway target. Use this to connect the gateway to private resources in your VPC.
Type: PrivateEndpoint object
Note: This object is a Union. Only one member of this object can be specified or returned.
Required: No
- targetConfiguration
-
The configuration settings for the target, including endpoint information and schema definitions.
Type: TargetConfiguration object
Note: This object is a Union. Only one member of this object can be specified or returned.
Required: Yes
Response Syntax
HTTP/1.1 202
Content-type: application/json
{
"authorizationData": { ... },
"certificateConfigurations": [
{ ... }
],
"createdAt": "string",
"credentialProviderConfigurations": [
{
"credentialProvider": { ... },
"credentialProviderType": "string"
}
],
"description": "string",
"gatewayArn": "string",
"lastSynchronizedAt": "string",
"metadataConfiguration": {
"allowedQueryParameters": [ "string" ],
"allowedRequestHeaders": [ "string" ],
"allowedResponseHeaders": [ "string" ]
},
"name": "string",
"privateEndpoint": { ... },
"privateEndpointManagedResources": [
{
"domain": "string",
"resourceAssociationArn": "string",
"resourceGatewayArn": "string"
}
],
"protocolType": "string",
"status": "string",
"statusReasons": [ "string" ],
"targetConfiguration": { ... },
"targetId": "string",
"updatedAt": "string"
}
Response Elements
If the action is successful, the service sends back an HTTP 202 response.
The following data is returned in JSON format by the service.
-
OAuth2 authorization data for the created gateway target. This data is returned when a target is configured with a credential provider with authorization code grant type and requires user federation.
Type: AuthorizationData object
Note: This object is a Union. Only one member of this object can be specified or returned.
- certificateConfigurations
-
The private certificate authority (CA) configurations for the gateway target.
Type: Array of CertificateConfiguration objects
Array Members: Fixed number of 1 item.
- createdAt
-
The timestamp when the target was created.
Type: Timestamp
- credentialProviderConfigurations
-
The credential provider configurations for the target.
Type: Array of CredentialProviderConfiguration objects
Array Members: Fixed number of 1 item.
- description
-
The description of the target.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 200.
- gatewayArn
-
The Amazon Resource Name (ARN) of the gateway.
Type: String
Pattern:
arn:aws(|-cn|-us-gov):bedrock-agentcore:[a-z0-9-]{1,20}:[0-9]{12}:gateway/([0-9a-z][-]?){1,48}-[a-z0-9]{10} - lastSynchronizedAt
-
The last synchronization of the target.
Type: Timestamp
- metadataConfiguration
-
The metadata configuration that was applied to the created gateway target.
Type: MetadataConfiguration object
- name
-
The name of the target.
Type: String
Pattern:
([0-9a-zA-Z][-]?){1,100} - privateEndpoint
-
The private endpoint configuration for the gateway target.
Type: PrivateEndpoint object
Note: This object is a Union. Only one member of this object can be specified or returned.
- privateEndpointManagedResources
-
The managed resources created by the gateway for private endpoint connectivity.
Type: Array of ManagedResourceDetails objects
- protocolType
-
The protocol type of the created gateway target.
Type: String
Valid Values:
MCP | HTTP - status
-
The current status of the target.
Type: String
Valid Values:
CREATING | UPDATING | UPDATE_UNSUCCESSFUL | DELETING | READY | FAILED | SYNCHRONIZING | SYNCHRONIZE_UNSUCCESSFUL | CREATE_PENDING_AUTH | UPDATE_PENDING_AUTH | SYNCHRONIZE_PENDING_AUTH - statusReasons
-
The reasons for the current status of the target.
Type: Array of strings
Array Members: Minimum number of 0 items. Maximum number of 100 items.
Length Constraints: Minimum length of 0. Maximum length of 2048.
- targetConfiguration
-
The configuration settings for the target.
Type: TargetConfiguration object
Note: This object is a Union. Only one member of this object can be specified or returned.
- targetId
-
The unique identifier of the created target.
Type: String
Pattern:
[0-9a-zA-Z]{10} - updatedAt
-
The timestamp when the target was last updated.
Type: Timestamp
Errors
For information about the errors that are common to all actions, see Common Error Types.
- AccessDeniedException
-
This exception is thrown when a request is denied per access permissions
HTTP Status Code: 403
- ConflictException
-
This exception is thrown when there is a conflict performing an operation
HTTP Status Code: 409
- InternalServerException
-
This exception is thrown if there was an unexpected error during processing of request
HTTP Status Code: 500
- ResourceNotFoundException
-
This exception is thrown when a resource referenced by the operation does not exist
HTTP Status Code: 404
- ServiceQuotaExceededException
-
This exception is thrown when a request is made beyond the service quota
HTTP Status Code: 402
- ThrottlingException
-
This exception is thrown when the number of requests exceeds the limit
HTTP Status Code: 429
- ValidationException
-
The input fails to satisfy the constraints specified by the service.
HTTP Status Code: 400
See Also
For more information about using this API in one of the language-specific AWS SDKs, see the following: